<?php 
##
#	Project: PHPDisk
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: links.inc.php 217 2009-03-05 09:47:52Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();
define('SCRIPT_NAME',$item);

require_once lang('adm_'.SCRIPT_NAME);

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'index':
		if($task =='update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$show_order = gpc('show_order','P',array());
			$linkids = gpc('linkids','P',array());
			$link_titles = gpc('link_titles','P',array());

			for($i =0;$i<count($linkids);$i++){
				$title = $db->escape(trim(replace_js($link_titles[$i])));
				if($title){
					$db->query_unbuffered("update pd_links set show_order='".(int)$show_order[$i]."',title='$title' where linkid='".(int)$linkids[$i]."'");
				}
			}
			redirect(urr("admincp","item=links&action=index"),'',0);
			
		}else{
			$q = $db->query("select * from pd_links order by show_order asc,linkid asc");
			$links = array();
			while($rs = $db->fetch_array($q)){
				$rs['logo'] = $rs['logo'] ? '<img src="'.$rs['logo'].'" width="88" height="31" border="0"/>' : "--";
				$rs['status_text'] = $rs['is_hidden'] ? '<span class="txtblue">'.$lang['display'].'</span>' : $lang['hidden'];
				$links[] = $rs;
			}
			$db->free($q);
			unset($rs);
			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
	
	case 'add_link':
	
		if($task =='add_link'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$link_title = trim(gpc('link_title','P',''));
			$link_url = trim(gpc('link_url','P',''));
			$link_logo = trim(gpc('link_logo','P',''));
			
			if(checklength($link_title,2,100)){
				$error = true;
				$sysmsg[] = $lang['link_title_error'];
			}
			if(checklength($link_url,5,100)){
				$error = true;
				$sysmsg[] = $lang['link_url_error'];
			}
			if(substr($link_url,0,7) != 'http://'){
				$error = true;
				$sysmsg[] = $lang['link_url_prefix'];
			}
			$rs = $db->fetch_one_array("select count(*) as total from pd_links where url='".$db->escape($link_url)."'");
			if($rs['total'] >0){
				$error = true;
				$sysmsg[] = $lang['link_url_exists'];
			}
			unset($rs);
			
			if(!$error){
				$ins = array(
					'title' => $db->escape(replace_js($link_title)),
					'url' => $db->escape(replace_js($link_url)),
					'logo' => $db->escape(replace_js($link_logo)),
				);
				$db->query("insert into pd_links set ".$db->sql_array($ins).";");
				redirect(urr("admincp","item=links&action=index"),'',0);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$link_url = 'http://';
			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
	
	case 'modify_link':
		$linkid = (int)gpc('linkid','GP',0);
		if($task =='modify_link'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$link_title = trim(gpc('link_title','P',''));
			$link_url = trim(gpc('link_url','P',''));
			$link_logo = trim(gpc('link_logo','P',''));
			
			if(checklength($link_title,2,100)){
				$error = true;
				$sysmsg[] = $lang['link_title_error'];
			}
			if(checklength($link_url,5,100)){
				$error = true;
				$sysmsg[] = $lang['link_url_error'];
			}
			if(substr($link_url,0,7) != 'http://'){
				$error = true;
				$sysmsg[] = $lang['link_url_prefix'];
			}
			$rs = $db->fetch_one_array("select count(*) as total from pd_links where url='".$db->escape($link_url)."'");
			if($rs['total'] >1){
				$error = true;
				$sysmsg[] = $lang['link_url_exists'];
			}
			unset($rs);
			
			if(!$error){
				$ins = array(
					'title' => $db->escape(replace_js($link_title)),
					'url' => $db->escape(replace_js($link_url)),
					'logo' => $db->escape(replace_js($link_logo)),
				);
				$db->query_unbuffered("update pd_links set ".$db->sql_array($ins)." where linkid='$linkid' limit 1;");
				redirect(urr("admincp","item=links&action=index"),'',0);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$rs = $db->fetch_one_array("select * from pd_links where linkid='$linkid'");
			if($rs){
				$link_title = $rs['title'];
				$link_url = $rs['url'];
				$link_logo = $rs['logo'];
			}
			unset($rs);
			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}	
	break;
	
	case 'delete_link':
		$linkid = (int)gpc('linkid','G',0);
		$db->query_unbuffered("delete from pd_links where linkid='$linkid' limit 1");
		redirect(urr("admincp","item=links&action=index"),'',0);	
	break;
	
	case 'change_status':
		$linkid = (int)gpc('linkid','G',0);
		$rs = $db->fetch_one_array("select is_hidden from pd_links where linkid='$linkid'");
		$status = $rs['is_hidden'] ? 0 : 1; 
		unset($rs);
		$db->query_unbuffered("update pd_links set is_hidden='$status' where linkid='$linkid'");
		redirect(urr("admincp","item=links&action=index"),'',0);	
	break;
	
	default:
		redirect(urr("admincp","item=links&action=index"),'',0);
}

?>