<?php 
##
#	Project: PHPDisk
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: public.inc.php 250 2009-03-10 17:29:43Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();
define('SCRIPT_NAME',$item);

require_once lang('adm_'.SCRIPT_NAME);

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'index':
		if($task =='check_public'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array(''));
			
			if(count($file_ids) <1){
				$error = true;
				$sysmsg[] = $lang['please_select_check_files'];
			}else{
				for($i=0;$i<count($file_ids);$i++){
					$file_str .= $file_ids[$i].',';
				}
				$file_str = substr($file_str,0,-1);
			}
			$db->query_unbuffered("update pd_publics set is_checked=1 where file_id in ($file_str)");
			redirect(urr("admincp","item=public&action=index&view=checked_file"),'',0);

		}elseif($task =='delete_to_recycle'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array(''));
			if(count($file_ids) <1){
				$error = true;
				$sysmsg[] = $lang['please_select_delete_files'];
			}else{
				for($i=0;$i<count($file_ids);$i++){
					$file_str .= $file_ids[$i].',';
				}
				$file_str = substr($file_str,0,-1);
			}
			$q = $db->query_unbuffered("update pd_publics set in_recycle=1 where file_id in ($file_str)");

			$sysmsg[] = $lang['public_file_recycle_success'];
			redirect(urr("admincp","item=public&action=index&view=public_recycle"),$sysmsg);
			
		}else{
			$perpage = $settings['perpage'];
			$view = trim(gpc('view','G',''));
			$sql_ext = "";
			switch($view){
				case 'all_file':
					$sql_ext = "";
				break;
				case 'uncheck_file':
					$sql_ext = " where is_checked=0 and in_recycle=0";
				break;
				case 'checked_file':
					$sql_ext = " where is_checked=1 and in_recycle=0";
				break;
				case 'public_recycle':
					$sql_ext = " where in_recycle=1";
				break;
			}
			$rs = $db->fetch_one_array("select count(*) as total_num from pd_publics {$sql_ext}");
			$total_num = $rs['total_num'];
			$start_num = ($pg-1) * $perpage;
			
			$q = $db->query("select * from pd_publics {$sql_ext} order by file_id desc limit $start_num,$perpage");
			$files_array = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_name_all'] = $rs['file_name'].$tmp_ext;
				$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,30);
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = custom_time("Y-m-d",$rs['file_time']);
				$files_array[] = $rs;
			}
			$db->free($q);
			unset($rs);
			$page_nav = multi($total_num, $perpage, $pg, urr("admincp","item=$item&action=$action"));
			
			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
	
	case 'search':
		$word = trim(gpc('word','G',''));
		$word_str = $db->escape(str_replace('　',' ',replace_inject_str($word)));
		$arr = explode(' ',$word_str);
		if(count($arr)>1){
			for($i=0;$i<count($arr);$i++){
				if(trim($arr[$i]) <> ''){
					$str .= " (file_name like '%{$arr[$i]}%' or file_extension like '%{$arr[$i]}%') and";
				}	
			}
			$str = substr($str,0,-3);
			$sql_keyword = " (".$str.")";
			
		}else{
			$sql_keyword = " (file_name like '%{$word_str}%' or file_extension like '%{$word_str}%')";
		}
		$sql_do = " pd_publics where in_recycle=0 and {$sql_keyword}";
	
		$rs = $db->fetch_one_array("select count(*) as total_num from {$sql_do}");
		$total_num = $rs['total_num'];
		$start_num = ($pg-1) * $perpage;
		
		$q = $db->query("select * from {$sql_do} order by file_id desc limit $start_num,$perpage");
		$files_array = array();
		while($rs = $db->fetch_array($q)){
			$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
			$rs['file_name_all'] = $rs['file_name'].$tmp_ext;
			$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,30);
			$rs['file_size'] = get_size($rs['file_size']);
			$rs['file_time'] = custom_time("Y-m-d",$rs['file_time']);
			$files_array[] = $rs;
		}
		$db->free($q);
		unset($rs);
				$page_nav = multi($total_num, $perpage, $pg, urr("admincp","item=$item&action=search&word=".rawurlencode($word).""));
		
		require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);

	break;

	case 'setting':
		if($task == 'setting'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$setting = array(
				'public_file_path' => '',
				'public_upload' => 0,
				'anonymous_upload' => 0,
				'check_public_file' => 0,
				'public_max_flow_view' => '',
				'public_max_flow_down' => '',
			);
			$settings = gpc('setting','P',$setting);
			
			$bad_dirs = array('admin','docs','images','includes','install','languages','modules','system','templates','filestores','tools');
			if(in_array($settings['public_file_path'],$bad_dirs)){
				$error = true;
				$sysmsg[] = '"'.$settings['public_file_path'].'"'.$lang['system_reserve_folder'];
			}
			if(checklength($settings['public_file_path'],2,30)){
				$error = true;
				$sysmsg[] = $lang['public_file_path_error'];
			}
			if(!$error){
				foreach($settings as $k => $v){
					$sqls .= "('$k','".$db->escape($v)."'),";
				}
				$sqls = substr($sqls,0,-1);
				$db->query("replace into pd_settings(vars,value) values $sqls ;");
								write_cache('settings');
				
				$sysmsg[] = $lang['public_update_success'];
				redirect(urr("admincp","item=public&action=setting"),$sysmsg);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$public_file_real_path = PHPDISK_ROOT.$settings['public_file_path'];
			if(!is_dir($public_file_real_path)){
				$public_file_path_tips = $lang['public_file_path_not_exists'];
			}
			$setting = array();
			$q = $db->query("select * from pd_settings");
			while($rs = $db->fetch_array($q)){
				$setting[$rs['vars']] = $rs['value'];
			}
			$db->free($q);
			unset($rs);

			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
	
	case 'file_delete':
		$file_id = (int)gpc('file_id','G',0);
		$db->query_unbuffered("update pd_publics set in_recycle=1 where file_id='$file_id'");
		redirect(urr("admincp","item=public&action=index&view=public_recycle"),'',0);
	break;
	
	case 'recycle_delete':
		$file_id = (int)gpc('file_id','G',0);
		$rs = $db->fetch_one_array("select folder_index,file_real_name from pd_publics where file_id='$file_id'");
		if($rs){
			@unlink(PHPDISK_ROOT.$settings['public_file_path'].'/'.$rs['folder_index'].'/'.$rs['file_real_name']);
			$db->query_unbuffered("delete from pd_publics where file_id='$file_id'");
		}
		redirect(urr("admincp","item=public&action=index&view=public_recycle"),'',0);
	break;
	
	case 'reset_bw':
		if($task =='view_reset'){
			$db->query("replace into pd_stats(vars,value) values('public_view_flow_count',0)");
			write_cache('stats');
			$sysmsg[] = $lang['reset_view_flow_success'];
		}elseif($task =='down_reset'){
			$db->query("replace into pd_stats(vars,value) values('public_down_flow_count',0)");
			write_cache('stats');
			$sysmsg[] = $lang['reset_down_flow_success'];
		}
		redirect(urr("admincp","item=public&action=setting"),$sysmsg);
		
	break;
	
	default:
		redirect(urr("admincp","item=public&action=index"),'',0);	
}

?>