<?php 
##
#	Project: PHPDisk
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: settings.inc.php 247 2009-03-09 17:27:53Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();
define('SCRIPT_NAME',$item);

require_once lang('adm_'.SCRIPT_NAME);

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'base':
		
		if($task =='base'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$setting = array(
				'site_title' => '',
				'meta_keywords' => '',
				'meta_description' => '',
				'miibeian' => '',
				'contact_us' => '',
				'site_stat' => '',
				'phpdisk_url' => '',
				'file_path' => '',
				'allow_access' => '1',
				'close_access_reason' => '',
				'allow_register' => '1',
				'close_register_reason' => '',
				'extract_code_length' => '12',
				'gzipcompress' => 0,
				'debug_info' => 0,
				'open_demo_login' => 0,
				'max_file_size' => '',
				'perpage' => 0,
			);
			$settings = gpc('setting','P',$setting);
						if(checklength($settings['site_title'],2,100)){
				$error = true;
				$sysmsg[] = $lang['site_title_error'];
			}
			if(strlen($settings['phpdisk_url']) <10 || (substr($settings['phpdisk_url'],0,7) !='http://' && substr($settings['phpdisk_url'],0,8) !='https://')){
				$error = true;
				$sysmsg[] = $lang['phpdisk_url_error'];
			}
			$bad_dirs = array('admin','docs','images','includes','install','languages','modules','system','templates','publicstores','tools');
			if(in_array($settings['file_path'],$bad_dirs)){
				$error = true;
				$sysmsg[] = '"'.$settings['file_path'].'"'.$lang['system_reserve_folder'];
			}
			if(checklength($settings['file_path'],2,20)){
				$error = true;
				$sysmsg[] = $lang['file_path_error'];
			}
			if(!checkemail($settings['contact_us'])){
				$error = true;
				$sysmsg[] = $lang['contact_us_error'];
			}
			if(!$settings['allow_access']){
				if(checklength($settings['close_access_reason'],2,200)){
					$error = true;
					$sysmsg[] = $lang['close_access_reason_error'];
				}
			}
			if(!$settings['allow_register']){
				if(checklength($settings['close_register_reason'],2,200)){
					$error = true;
					$sysmsg[] = $lang['close_register_reason_error'];
				}
			}
			$settings['perpage'] = !is_numeric($settings['perpage']) ? 20 : (int)$settings['perpage'];
			
			if(!$error){
				foreach($settings as $k => $v){
					$sqls .= "('$k','".$db->escape(trim($v))."'),";
				}
				$sqls = substr($sqls,0,-1);
				$db->query("replace into pd_settings(vars,value) values $sqls ;");
				
				write_cache('settings');
				
				$sysmsg[] = $lang['settings_update_success'];
				redirect(urr("admincp","item=settings&action=base"),$sysmsg);
				
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
			
		}else{
			$file_real_path = PHPDISK_ROOT.$settings['file_path'];
			if(!is_dir($file_real_path)){
				$file_path_tips = $lang['file_path_not_exists'];
			}
						$upload_max = get_byte_value(ini_get('upload_max_filesize'));
			$post_max = get_byte_value(ini_get('post_max_size'));
			$settings_max = $settings['max_file_size'] ? get_byte_value($settings['max_file_size']) : 0;
			$max_php_file_size = min($upload_max, $post_max);
			$max_file_size_byte = ($settings_max && $settings_max <= $max_php_file_size) ? $settings_max : $max_php_file_size;
			$max_user_file_size = get_size($max_file_size_byte,'B',0);

			$setting = $settings;

			require_once template(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
}
?>