<?php
##
#	Project: PHPDisk
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: install.php 263 2009-03-11 06:31:44Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

error_reporting(0);

@require_once "./install/zh-cn.lang.php";

if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	define('LF',"\r\n");
} else {
	define('LF',"\n");
}
define('PHPDISK_ROOT',dirname(__FILE__).'/');
define('IN_PHPDISK', true);
define('NOW_YEAR','2009');
ob_start();
require_once "./phpdisk_version.php";

function stripslashes_array(&$array) {
	if (is_array($array)) {
		foreach ($array as $k => $v) {
			$array[$k] = stripslashes_array($v);
		}
	} else if (is_string($array)) {
		$array = stripslashes($array);
	}
	return $array;
}

if (get_magic_quotes_gpc()) {
    $_GET = stripslashes_array($_GET);
    $_POST = stripslashes_array($_POST);
}

set_magic_quotes_runtime(0);

$step = $_GET['step'] ? (int)$_GET['step'] : (int)$_POST['step'];
$php_self = $_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME'];
$config_file = './system/configs.inc.php';

$sqlfile = './install/phpdisk.sql';
if(!file_exists($sqlfile) || !is_readable($sqlfile)) {
	exit($lang['db_file_not_exists']);
}
$fp = fopen($sqlfile, 'rb');
$sql = fread($fp, filesize($sqlfile));
fclose($fp);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>PHPDisk<?php echo PHPDISK_VERSION;?> <?php echo $lang['install_guide'] ?></title>
<link href="./install/style.css" rel="stylesheet" type="text/css" />
</head>
<body style="margin-top:5px">
<div id="main">
<?php if($step ==3 || $step ==4 || $step ==6){?>
  <form method="post" name="myform" action="<?php echo $php_self;?>" onsubmit="return chksubmit(this);">
<?php }else{?>  
  <form method="post" name="myform" action="<?php echo $php_self;?>">
<?php }?>
    <p class="title">PHPDisk <?php echo PHPDISK_VERSION;?> <?php echo $lang['install_guide'] ?></p>
    <hr noshade="noshade" />
<?php
if (!$step || $step == 1) {
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">1</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['user_license'] ?></p>
	<p align="center"><textarea rows="50" cols="100" readonly="readonly"><?php echo $lang['license_content'] ?></textarea>
	</p>
    <hr noshade="noshade" />
    <p align="right">
      <input type="hidden" name="step" value="2" />
      <input class="formbutton" type="submit" value="<?php echo $lang['agree'] ?>" />&nbsp;&nbsp;<input class="formbutton" type="button" value="<?php echo $lang['disagree'] ?>" onclick="javascript:window.close();" />
    </p>
<?php 
}else if($step ==2){
	$short_open_tag = @ini_get('short_open_tag');
	$system_dir = './system';
	$filestores_dir = './filestores';
	$publicstores_dir = './publicstores';
	$install_dir = './install';
	$chk_system_dir = is_writable($system_dir) ? 1 : 0;
	$chk_filestores_dir = is_writable($filestores_dir) ? 1 : 0;
	$chk_publicstores_dir = is_writable($publicstores_dir) ? 1 : 0;
	$chk_install_dir = is_writable($install_dir) ? 1 : 0;
	if($short_open_tag && $chk_system_dir && $chk_filestores_dir && $chk_publicstores_dir && $chk_install_dir){
		$install_halt =0;
	}else{
		$install_halt =1;
	}
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">2</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['install_note'] ?></p>
    <p><?php echo $lang['welcome_to_use'] ?> PHPDisk <?php echo PHPDISK_VERSION;?>，<?php echo $lang['install_settings'] ?>: </p>
    <ul>
      <li><?php echo $lang['mysql_server_or_ip'] ?> </li>
      <li><?php echo $lang['mysql_username_or_password'] ?> </li>
      <li><?php echo $lang['mysql_database_name'] ?> </li>
      <li><?php echo $system_dir ?> <?php echo $lang['check_dir1'] ?></li>
	  <li><?php echo $system_dir ?> <?php echo $lang['check_dir2'] ?>：<?php output_txt($chk_system_dir,1); ?></li>
      <li><?php echo $filestores_dir ?> <?php echo $lang['check_dir1'] ?></li>
	  <li><?php echo $filestores_dir ?> <?php echo $lang['check_dir2'] ?>：<?php output_txt($chk_filestores_dir,1); ?></li>
      <li><?php echo $publicstores_dir ?> <?php echo $lang['check_dir1'] ?></li>
	  <li><?php echo $publicstores_dir ?> <?php echo $lang['check_dir2'] ?>：<?php output_txt($chk_filestores_dir,1); ?></li>
      <li><?php echo $install_dir ?> <?php echo $lang['check_dir1'] ?></li>
	  <li><?php echo $install_dir ?> <?php echo $lang['check_dir2'] ?>：<?php output_txt($chk_install_dir,1); ?></li>
    </ul>
    <p><?php echo $lang['database_tips_info'] ?></p>
	<?php 
	if($short_open_tag !=1){
	?>
		<p class="txtgreen"><b><?php echo $lang['php_env_setting'] ?>：</b><?php echo $lang['short_open_tag'] ?></p>
	<?php 
	}
	?>
	<?php if(!$install_halt){?>
    <hr noshade="noshade" />
    <p align="right">
      <input type="hidden" name="step" value="3" />
      <input class="formbutton" type="submit" value="<?php echo $lang['next_step'] ?>" />
    </p>
	<?php }?>
<?php
} elseif ($step == 3) {

	$fp = fopen($config_file,'w'); 
	if (!$fp) { 
		exit("Can not open file <b>$config_file</b> .");
	} 
	@fclose($fp);
	$exist_error = false;
	$write_error = false;
	if (file_exists($config_file)) {
		$fileexists = output_txt(1, 0);
	} else {
		$fileexists = output_txt(0, 0);
		$exist_error = true;
	}
	if (is_writable($config_file)) {
		$filewriteable = output_txt(1, 0);
	} else {
		$filewriteable = output_txt(0, 0);
		$write_error = true;
	}
	if ($exist_error) {
		$config_info = $config_file.' '.$lang['config_file_not_exists'];
	} elseif($write_error) {
		$config_info = $lang['config_file_cant_write'];
	}
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">3</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['database_setting'] ?></p>
    <p><?php echo $config_file;?> <?php echo $lang['file_exists'] ?> <?php echo $fileexists;?></p>
    <p><?php echo $config_file;?> <?php echo $lang['file_writeable'] ?> <?php echo $filewriteable;?></p>
<?php
	if ($config_info) {
?>
    <p><?php echo $config_info;?></p>
    <hr noshade="noshade" />
    <p align="right">
      <input class="formbutton" type="button" value="<?php echo $lang['prev_step'] ?>" onclick="history.back(1)" />
    </p>
<?php
	} else {
?>
    <hr noshade="noshade" />
    <table width="100%" border="0" cellspacing="0" cellpadding="4">
      <tr>
        <td width="30%" nowrap><?php echo $lang['dbhost'] ?>:</td>
        <td><input type="text" value="localhost" name="dbhost" class="formfield" style="width:150px"> <?php echo $lang['dbhost_tips'] ?></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['dbname'] ?>:</td>
        <td><input type="text" value="" name="dbname" class="formfield" style="width:150px"></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['dbuser'] ?>:</td>
        <td><input type="text" value="" name="dbuser" class="formfield" style="width:150px"></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['dbpasswd'] ?>:</td>
        <td><input type="password" value="" name="dbpasswd" class="formfield" style="width:150px"></td>
      </tr>
    </table>
	<script language="javascript">
	document.myform.dbhost.focus();
	function chksubmit(o){
		if(o.dbhost.value == ""){
			alert("<?php echo $lang['js_dbhost'] ?>");
			o.dbhost.focus();
			return false;
		}
		if(o.dbname.value == ""){
			alert("<?php echo $lang['js_dbname'] ?>");
			o.dbname.focus();
			return false;
		}
		if(o.dbuser.value == ""){
			alert("<?php echo $lang['js_dbuser'] ?>");
			o.dbuser.focus();
			return false;
		}
		if(o.dbpasswd.value == ""){
			alert("<?php echo $lang['js_dbpasswd'] ?>");
			o.dbpasswd.focus();
			return false;
		}
		o.s1.disabled = true;	
		return true;
	}
	</script>
    <p>&nbsp;</p>
    <p><?php echo $lang['database_tips_info'] ?></p>
    <hr noshade="noshade" />
    <p align="right">
      <input type="hidden" name="step" value="4" />
      <input class="formbutton" name="s1" type="submit" value="<?php echo $lang['next_step'] ?>" />
    </p>
    <?php
	}
} elseif ($step == 4) {
	if(trim($_POST['dbname']) == "" || trim($_POST['dbhost']) == "" || trim($_POST['dbuser']) == ""){

?>
    <p><?php echo $lang['fill_all_blank'] ?></p>
    <hr noshade="noshade" />
    <p align="right">
      <input class="formbutton" type="button" value="<?php echo $lang['prev_step'] ?>" onclick="history.back(1)" />
    </p>
<?php
	} else {
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">4</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['admin_account'] ?></p>
<?php
		if(is_writable($config_file)) {

			$dbhost = trim($_POST['dbhost']);
			$dbuser = trim($_POST['dbuser']);
			$dbpasswd = trim($_POST['dbpasswd']);
			$dbname = trim($_POST['dbname']);

			$str = "<?php".LF.LF;
			$str .= "// This is PHPDISK auto-generated file. Do NOT modify me.".LF.LF;
			$str .= "\$configs = array(".LF.LF;
			$str .= "\t'dbhost' => '$dbhost',".LF.LF;
			$str .= "\t'dbname' => '$dbname',".LF.LF;
			$str .= "\t'dbuser' => '$dbuser',".LF.LF;
			$str .= "\t'dbpasswd' => '$dbpasswd',".LF.LF;
			$str .= "\t'pconnect' => 0,".LF.LF;
			$str .= ");".LF.LF;
			$str .= "?>".LF;
			
			$fp = fopen($config_file,'w'); 
			if (!$fp) { 
				exit("Can not open file <b>$config_file</b> .");
			} 
			if(is_writable($config_file)){
				if(@fwrite($fp,$str)){
					$msg .= "<font color=blue>{$config_file} ".$lang['write_success']."</font>";
				}else{
					$msg .= "<font color=red>{$config_file} ".$lang['write_failture']."</font>";
					$flag = true;
				}
				@fclose($fp);
			}else{
				$msg .= "<font color=red>{$config_file} ".$lang['cant_write']."</font>";
				$flag = true;
			}
			echo $msg;
			if($flag){
				exit;
			}
		}
		
		require_once $config_file;
		require_once './includes/mysql.class.php';
		$db = new cls_mysql;

		$db->connect($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['dbname'],$configs['pconnect']);
		unset($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['pconnect']);

		$msg = '';
		$error = false;
		$curr_os = PHP_OS;
		$curr_php_version = PHP_VERSION;
		if($curr_php_version < '4.0.6') {
			$msg .= "<font color=\"#FF0000\">".$lang['php_version_too_lower']."</font><br />";
			$error = true;
		}

		$query = $db->query("SELECT VERSION()");
		$curr_mysql_version = $db->result($query, 0);
		if($curr_mysql_version < '4.1') {
			$msg .= "<font color=\"#FF0000\">".$lang['mysql_version_too_lower']."</font><br />";
			$error = true;
		}

		$db->select_db($configs['dbname']);
		if($db->get_error()) {
			if($db->get_error()) {
				$msg .= "<font color=\"#FF0000\">".$lang['database_not_found']."</font><br />";
				$error = true;
			} else {
				$db->select_db($configs['dbname']);
				$msg .= $lang['database_create_success']."<br />";
			}
		}
		
		$db->query("SELECT COUNT(*) FROM pd_users", 'SILENT');
		if(!$db->get_error()) {
			$msg .= "<font color=\"#FF0000\">".$lang['database_already_exists']."</font><br />";
			$alert = " onclick=\"return confirm('".$lang['database_confirm']."');\"";
		} else {
			$alert = '';
		}

		if($error) {
			$msg .= "<font color=\"#FF0000\">".$lang['file_not_chmod']."</font>";
		} else {
			$msg .= $lang['server_env_ok'];
		}
		if ($msg) {
			echo "<p>".$msg."</p>";
		}
		if($error) {
?>
    <p align="right">
      <input type="button" class="formbutton" value="<?php echo $lang['quit'] ?>" onclick="javascript: window.close();">
    </p>
<?php
		} else {
?>
    <p>&nbsp;</p>
    <table width="100%" border="0" cellspacing="0" cellpadding="4">
      <tr>
        <td width="30%" nowrap><?php echo $lang['username'] ?>:</td>
        <td><input type="text" value="" name="username" class="formfield" style="width:150px"></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['password'] ?>:</td>
        <td><input type="password" value="" name="password" class="formfield" style="width:150px"></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['confirm_password'] ?>:</td>
        <td><input type="password" value="" name="confirmpassword" class="formfield" style="width:150px"></td>
      </tr>
      <tr>
        <td width="30%" nowrap><?php echo $lang['email'] ?>:</td>
        <td><input type="text" value="" name="email" class="formfield" style="width:150px"></td>
      </tr>
    </table>
	<script language="JavaScript" type="text/javascript">
	document.myform.username.focus();
	function chksubmit(o){
		if(o.username.value == ""){
			alert("<?php echo $lang['js_username'] ?>");
			o.username.focus();
			return false;
		}
		if(o.password.value == ""){
			alert("<?php echo $lang['js_password'] ?>");
			o.password.focus();
			return false;
		}
		if(o.password.value.length <6){
			alert("<?php echo $lang['js_password_too_short'] ?>");
			o.password.focus();
			return false;
		}
		if(o.password.value != o.confirmpassword.value){
			alert("<?php echo $lang['js_confirm_password'] ?>");
			o.confirmpassword.focus();
			return false;
		}
		if(o.email.value == "" || o.email.value.indexOf('@') ==-1 || o.email.value.indexOf('.') ==-1){
			alert("<?php echo $lang['js_email'] ?>");
			o.email.focus();
			return false;
		}
		o.s1.disabled = true;	
		return true;
	}
	</script>
    <p>&nbsp;</p>
    <hr noshade="noshade" />
    <p align="right">
      <input type="hidden" name="step" value="5" />
      <input class="formbutton" name="s1" type="submit" value="<?php echo $lang['next_step'] ?>" <?php echo $alert;?> />
    </p>
<?php
		}
	}
} elseif ($step == 5) {
	$username = addslashes(trim($_POST['username']));
	$password = $_POST['password'];
	$confirmpassword = $_POST['confirmpassword'];
	$email = trim($_POST['email']);
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">5</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['check_user_info'] ?></p>
<?php
    if ($username == "" || $password == "" || $confirmpassword == "" || $email == '') {
		$msg = "<p>".$lang['fill_all_blank']."</p>";
		$error = true;
    } elseif (strlen($_POST['password']) < 6) {
		$msg = "<p>".$lang['s_password_too_short']."</p>";
		$error = true;
	} elseif ($password != $confirmpassword) {
		$msg = "<p>".$lang['s_password_not_same']."</p>";
		$error = true;
	} elseif (strlen($email) <6 || strpos($email,'@') ===false){
		$msg = "<p>".$lang['s_email']."</p>";
		$error = false;
    } else {
		$msg = "<p>".$lang['s_check_server_env']."</p>";
		$error = false;
	}
	$name_key = array("\\",'&',' ',"'",'"','/','*',',','<','>',"\r","\t","\n",'#','$','(',')','%','@','+','?',';','^');
	foreach($name_key as $value){
		if (strpos($username,$value) !== false){ 
			$msg = "<p>".$lang['bad_chars']."</p>";
			$error = true;
		}
	}
	if ($error) {
		echo $msg;
?>
    <hr noshade="noshade" />
    <p align="right">
      <input class="formbutton" type="button" value="<?php echo $lang['prev_step'] ?>" onclick="history.back(1)" />
    </p>
<?php
	} else {
		echo $msg;
?>
    <p>&nbsp;</p>
    <p><?php echo $lang['username'] ?>: <?php echo $username;?><input type="hidden" name="username" value="<?php echo $username;?>" /></p>
    <p><?php echo $lang['password'] ?>: <?php echo $password;?><input type="hidden" name="password" value="<?php echo $password;?>" /></p>
    <p><?php echo $lang['email'] ?>: <?php echo $email;?><input type="hidden" name="email" value="<?php echo $email;?>" /></p>
    <p>&nbsp;</p>
    <p><?php echo $lang['user_info_right'] ?></p>
    <hr noshade="noshade" />
    <p align="right">
      <input type="hidden" name="step" value="6" />
      <input class="formbutton" type="submit" value="<?php echo $lang['next_step'] ?>" />
    </p>
<?php
	}
} elseif ($step == 6) {
	$username = trim($_POST['username']);
	$password = trim($_POST['password']);
	$email = trim($_POST['email']);
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">6</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['import_data'] ?></p>
	<p>
<?php
	require_once $config_file;
	require_once './includes/mysql.class.php';

	$db = new cls_mysql;
	$db->connect($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['dbname'],$configs['pconnect']);
	unset($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['pconnect']);

	$sql = preg_replace("/\-\-.*[\r\n]+/i","",trim($sql));
	
	runquery($sql);
	
	$ins = array(
		'username' => $db->escape($username),
		'password' => md5($password),
		'email' => $db->escape($email),
		'gid' => 1,
		'reg_time' => time(),
		'reg_ip' => $_SERVER['REMOTE_ADDR'],
	);
	$db->query("insert into pd_users set ".$db->sql_array($ins).";");
	$userid = $db->insert_id();
	
	$ins2 = array(
		'disk_name' => 'A',
		'disk_description' => '',
		'userid' => (int)$userid,
		'in_time' => time(),
	);
	$db->query("insert into pd_disks set ".$db->sql_array($ins2).";");
	$disk_id = $db->insert_id();
	
	$ins3 = array(
		'folder_name' => 'Default Folder',
		'folder_description' => '',
		'disk_id' => (int)$disk_id,
		'userid' => (int)$userid,
		'in_time' => time(),
	);
	$db->query("insert into pd_folders set ".$db->sql_array($ins3).";");
	write_file('./install/install.lock','PHPDisk installed! Time:'.date("Y-m-d H:i:s"));
?>
    </p>
    <p><?php echo $lang['all_create'] ?><?php echo $tablenum;?> <?php echo $lang['tables'] ?>.</p>
    <hr noshade="noshade" />
    <p><?php echo $lang['base_settings'] ?>：</p>
	<?php 
	$arr = explode('install',$_SERVER['REQUEST_URI']);
	$phpdisk_url = 'http://'.$_SERVER['SERVER_NAME'].$arr[0];
	?>
    <table width="100%" border="0" cellspacing="0" cellpadding="4">
      <tr>
        <td width="15%" nowrap><?php echo $lang['site_title'] ?>:</td>
        <td><input type="text" value="<?php echo $lang['project_name'] ?>" name="site_title" class="formfield" style="width:200px" maxlength="50"></td>
      </tr>
      <tr>
        <td width="15%" nowrap><?php echo $lang['phpdisk_url'] ?>:</td>
        <td><input type="text" value="<?php echo $phpdisk_url; ?>" name="phpdisk_url" class="formfield" style="width:300px" maxlength="50"> <?php echo $lang['phpdisk_url_tips'] ?></td>
      </tr>
      <tr>
        <td width="15%" nowrap><?php echo $lang['open_gzip'] ?>:</td>
        <td><input type="radio" name="gzipcompress" value="1" checked="checked" /><?php echo $lang['yes'] ?>
		<input type="radio" name="gzipcompress" value="0" /><?php echo $lang['no'] ?></td>
      </tr>
	</table>  
    <input type="hidden" name="username" value="<?php echo $username;?>" />
    <input type="hidden" name="password" value="<?php echo $password;?>" />
	<script language="javascript">
	function chksubmit(o){
		if(o.site_title.value == ""){
			alert("<?php echo $lang['js_site_title'] ?>");
			o.site_title.focus();
			return false;
		}
		if(o.phpdisk_url.value == ""){
			alert("<?php echo $lang['js_phpdisk_url'] ?>");
			o.phpdisk_url.focus();
			return false;
		}
	}
	</script>
    <p align="right">
      <input type="hidden" name="step" value="7" />
      <input class="formbutton" type="submit" value="<?php echo $lang['next_step'] ?>" />
    </p>
<?php 
}elseif($step ==7){
	require_once $config_file;
	require_once './includes/mysql.class.php';

	$db = new cls_mysql;
	$db->connect($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['dbname'],$configs['pconnect']);
	unset($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['pconnect']);

	$site_title = trim($_POST['site_title']);
	$phpdisk_url = trim($_POST['phpdisk_url']);
	$gzipcompress = trim($_POST['gzipcompress']);
	$username = trim($_POST['username']);
	$password = trim($_POST['password']);
	
    if ($site_title == "" || $phpdisk_url == "") {
		$msg = "<p>".$lang['site_title_and_phpdisk_url']."</p>";
		$error = true;
	}
	
	if ($error) {
		echo $msg;
?>
    <hr noshade="noshade" />
    <p align="right">
      <input class="formbutton" type="button" value="<?php echo $lang['prev_step'] ?>" onclick="history.back(1)" />
    </p>
<?php
	} else {
?>
    <p class="title"><?php echo $lang['the'] ?>(<span class="txtblue">7</span>/7)<?php echo $lang['step'] ?>:<?php echo $lang['finished_install'] ?></p>
	<p>
<?php	
		$settings = array(
			'site_title' => $db->escape($site_title),
			'phpdisk_url' => $db->escape($phpdisk_url),
			
			'gzipcompress' => (int)$gzipcompress,
			'max_file_size' => 0,
			'perpage' => 50,
		);
		$setting_file = './system/settings.inc.php';
		$str = $str2 = '';
		foreach($settings as $k => $v){
			$str2 .= "('$k','$v'),";
		}
		$str2 = substr($str2,0,-1);
		$db->query("replace into pd_settings(vars,value) values $str2 ;");
		
		$q = $db->query("select * from pd_settings");
		while($rs = $db->fetch_array($q)){
			$str_c .= "\t'".$rs['vars']."' => '".$rs['value']."',".LF.LF;
		}
		$db->free($q);
		unset($rs);
		
		$str = "<?php".LF.LF;
		$str .= "// This is PHPDISK auto-generated file. Do NOT modify me.".LF;
		$str .= "// Cache Time: ".date("Y-m-d H:i:s").LF.LF;
		$str .= "\$settings = array(".LF.LF;
		$str .= $str_c;
		$str .= ");".LF.LF;
		$str .= "?>".LF;
		
		$msg = '';
		$fp = fopen($setting_file,'w'); 
		if (!$fp) { 
			exit("Can not open file <b>$setting_file</b> .");
		} 
		if(is_writable($setting_file)){
			if(@fwrite($fp,$str)){
				$msg .= "<font color=blue>{$setting_file} 写入成功</font>";
			}else{
				$msg .= "<font color=red>{$setting_file} 写入失败</font>";
				$flag = true;
			}
			@fclose($fp);
		}else{
			$msg .= "<font color=red>{$setting_file} 不能写入！</font>";
			$flag = true;
		}
		echo $msg;
		if($flag){
			exit;
		}
?>
    <hr noshade="noshade" />
    <p><?php echo $lang['finished_tips'] ?></p>
    <p><?php echo $lang['thanks'] ?></p>
    <p>&nbsp;</p>
    <p><?php echo $lang['username'] ?>: <?php echo $username;?></p>
    <p><?php echo $lang['password'] ?>: <?php echo $password;?></p>
    <p>&nbsp;</p>
    <p><a href="./"><?php echo $lang['visit_phpdisk'] ?></a></p>
    <hr noshade="noshade" />
    <p align="right"><a href="http://www.phpdisk.com/" target="_blank"><?php echo $lang['phpdisk_official_site'] ?></a></p>
<?php
	}
}
?>
  </form>
</div>
<strong>Powered by <a href="http://www.phpdisk.com/" target="_blank">PHPDisk Team</a> <?php echo PHPDISK_VERSION;?> (C) 2008-<?php echo date("Y",time());?> All Rights Reserved.</strong>
</body>
</html>
<?php

function output_txt($output_txt = 1, $output = 1) {
	if($output_txt) {
		$text = '... <font color="#0000EE">Yes</font><br />';
		if(!$output) {
			return $text;
		}
		echo $text;
	} else {
		$text = '... <font color="#FF0000">No</font><br />';
		if(!$output) {
			return $text;
		}
		echo $text;
	}
}

function runquery($sql) {
	global $db, $tablenum,$lang;

	$sql = str_replace("\r", "\n", $sql);

	foreach(explode(";\n", trim($sql)) as $query) {
		$query = trim($query);
		if($query) {
			if(substr($query, 0, 26) == 'CREATE TABLE IF NOT EXISTS') {
				$name = preg_replace("/CREATE TABLE IF NOT EXISTS `([a-z0-9_]+)` .*/is", "\\1", $query);
				echo $lang['create_table'].' '.$name.' ... <font color="#0000EE">'.$lang['success'].'</font><br />';
				$db->query($query);
				$tablenum++;
			} else {
				$db->query($query);
			}
		}
	}
}
function write_file($f,$str,$mode = 'wb') { 
    $fp = fopen($f,$mode); 
    if (!$fp) { 
        exit("Can not open file <b>$f</b> .code:1");
    } 
	if(is_writable($f)){
		if(!fwrite($fp,$str)){
			exit("Can not write file <b>$f</b> .code:2");
		} 
	}else{
		exit("Can not write file <b>$f</b> .code:3");
	}
    fclose($fp); 
} 

?>